import { ICollectionRef } from "./types";
declare type QueryTypes = "keys" | "get" | "set" | "update" | "delete" | "add" | "unsubscribe" | "collections" | "delete-collection" | "snapshot";
declare const QueryRequest: unique symbol;
declare const Snapshots: unique symbol;
export default class Database {
    static WebSocket: typeof WebSocket;
    private initLock;
    private socket;
    private requests;
    constructor(url: string, database: string, accesskey?: string, authkey?: string, rootkey?: string);
    [Snapshots]: Map<string, (data: any) => void>;
    private handleSnapshot;
    private handleResponse;
    [QueryRequest]<T = any>(type: QueryTypes, path: string[], data?: any, id?: string): Promise<T>;
    collection<T = any>(name: string): ICollectionRef<T>;
    collections(): Promise<ICollectionRef[]>;
    close(): void;
}
export {};
